/*********** AVR155 : AVRTWIgpI2C LCD\ւ̱@ ***************

޲		: ATmega163

̧ٖ		: TWI_driver.c

Ŕԍ		: 1.0

		: TWI_driver.cAVRTWIeՂɂײނłB͏]
			  uڽA޲ĐA߲܂1KvłBׂ߲͑޲
			  Ă𓾂ꏊ܂͎M޲Ăuꎞޯ̧̏ꏊm点܂B
			  ʐM̐ۂɈˑāAȂ̏ꍇSUCCESSA܂ُ픭
			  ̏ꍇAVRTWSRlԂ܂Bײނ͑SĂ̐MAJn/
			  ~A޽ُ܂B

			  ײނ̓o͂ɉ葽̎ɂĂ͉pLq
			  B

		: Asmund Saetre

ύXL^	: 2000N125쐬

******************************************************************************/
#include "TWI_driver.h"

/******************************************************************************
 ֐ : char Init_TWI(void)
 TWI\ݒ
 ޯđx 	 : 4MHz̼ ۯ100kbps
 g̱ڽ : OWN_ADR (TWI_driver.hŒ`)
******************************************************************************/

char Init_TWI(void)
{
  TWAR = OWN_ADR;							// g̱ڽݒ
  TWBR = 12;                    			// ޯđx100kbps(/4MHz)ɐݒ
  TWCR = (1<<TWEN);							// TWI̪
  return 1;
}

/******************************************************************************
 ֐ : void Wait_TWI_int(void)
 TWI荞ݗv׸=1܂őҋ@
******************************************************************************/
void Wait_TWI_int(void)
{
  while (!(TWCR & (1<<TWINT)));				// TWINT=1܂őҋ@
}

/******************************************************************************
 ֐ :unsigned char Send_start(void)
 ޽ɊJn𑗏oČʂ邽߂TWINT=1܂őҋ@Bs̏ꍇTWSRlA
 ̏ꍇSUCCESSԂ܂B
******************************************************************************/
unsigned char Send_start(void)
{
  TWCR = ((1<<TWINT)+(1<<TWSTA)+(1<<TWEN));	// Jno
  Wait_TWI_int();							// TWINT=1܂őҋ@
  if((TWSR != START)&&(TWSR != REP_START))	// (đ)Jn(($10)$08)ȊOȂA
	return TWSR;							// (TWSR)lƋɕA
  return SUCCESS;							// ȂAlƋɕA
}

/******************************************************************************
 ֐ : void Send_stop(void)
 ޽ɒ~o
******************************************************************************/
void Send_stop(void)
{
  TWCR = ((1<<TWEN)+(1<<TWINT)+(1<<TWSTO));	// ~o
}

/******************************************************************************
 ֐ : unsigned char Send_to_TWI(tx_type *data_pack)
 TWIʐM֐B޽ɑ΂SĂ̐M܂B
******************************************************************************/
unsigned char Send_to_TWI(tx_type *data_pack)
{
  unsigned char state,i,j;

  state = SUCCESS;							// ߂l

  // wL(g̱ڽȊO)ŎsȂAp
  for(i=0;(data_pack[i].slave_adr != OWN_ADR)&&(state == SUCCESS);i++)
  {
	state = Send_start();					// (đ)Jno
	if (state == SUCCESS)					// ŁA
	  state = Send_adr(data_pack[i].slave_adr);		// ]uڽ+R/WM
	if(!(data_pack[i].slave_adr & R))		// MŁA
	{
	  for(j=0;((j<data_pack[i].size)&&(state == SUCCESS));j++)	// sȂASްM
		state = Send_byte(data_pack[i].data_ptr[j]);
	}	
	else									// MŁA
	{
	  for(j=0;((j<data_pack[i].size)&&(state == SUCCESS));j++)	// w萔/NACKM/s܂ްMp
		state = Get_byte(data_pack[i].data_ptr++,j);
	}
  }
  Send_stop();								// ~o
  return state;								// ԒlƋɕA
}

/******************************************************************************
 ֐ : unsigned char Send_byte(unsigned char data)
 ޽1޲đM
******************************************************************************/
unsigned char Send_byte(unsigned char data)
{
  Wait_TWI_int();							// TWINT=1܂őҋ@
  TWDR = data;								// M޲Đݒ
  TWCR = ((1<<TWINT)+(1<<TWEN));			// ް ޲đMJn(TWINT=0)
  Wait_TWI_int();							// TWINT=1܂őҋ@
  if(TWSR != MTX_DATA_ACK)					// NACKMŁA
	return TWSR;							// (TWSR)lƋɕA
  return SUCCESS;							// ACKMŁAlƋɕA
}

/******************************************************************************
 ֐ : unsigned char Send_adr(unsigned char adr)
 ޽SLA+R/WM
******************************************************************************/
unsigned char Send_adr(unsigned char adr)
{
  Wait_TWI_int();							// TWINT=1܂őҋ@

  TWDR = adr;
  TWCR = ((1<<TWINT)+(1<<TWEN));			// SLA+R/W޲đMJn(TWINT=0)

  Wait_TWI_int();							// TWINT=1܂őҋ@

  if((TWSR != MTX_ADR_ACK)&&(TWSR != MRX_ADR_ACK))	// NACKMŁA
	return TWSR;							// (TWSR)lƋɕA
  return SUCCESS;							// ACKMŁAlƋɕA
}

/******************************************************************************
 ֐ : unsigned char Get_byte(unsigned char *rx_ptr,char last_byte)
 ]u1޲ĂMACK𑗏o邽߂TWINT=1҂܂BŏI޲Ă̏ꍇA
 呕u͏]uɑM~m点邽߂NACK𑗏o܂B
******************************************************************************/
unsigned char Get_byte(unsigned char *rx_ptr,char last_byte)
{
  Wait_TWI_int();							// TWINT=1܂őҋ@

  if(last_byte)								// ŏI޲ĈȊOŁA
		//Clear int flag and enable acknowledge to receive data.
	TWCR = ((1<<TWINT)+(1<<TWEA)+(1<<TWEN));	// ACKwް ޲ĎMJn(TWINT=0)
  else										// ŏI޲ĂŁA
	TWCR = ((1<<TWINT)+(1<<TWEN));			// NACKwް ޲ĎMJn(TWINT=0)
  Wait_TWI_int();							// TWINT=1܂őҋ@
  *rx_ptr = TWDR;							// Mް ޲ĕۑ

  if(((TWSR == MRX_DATA_NACK)&&(last_byte == 0))||(TWSR == MRX_DATA_ACK))	// ŏI޲NACK܂͍ŏI޲ĈȊOACKŁA
	return SUCCESS;	  						// lƋɕA
  return TWSR;								// ȊO͏(TWSR)lƋɕA
}
